/*
Titre: Exercice6
Description: Programme qui permet d'exprimenter le passage par rfrence pour retourner plusieurs valeurs.
Le programme effectue la division entire et fournit le quotient et le reste. 
La division est effectue au sein d'une fonction qui retourne le quotient et le reste  travers des rfrences.

Auteur: Anis Boubaker
Date: 2018-02-01
*/

/***********COMMANDES PRPROCESSEUR*************/
#define _CRT_SECURE_NO_WARNINGS
#include <stdlib.h>
#include <stdio.h>

/***********CONSTANTES DE COMPILATION*************/


/********* DCLARATIONS DES FONCTION **************/
/*
Fonction: division_entiere
Description: Effectue la division entiere de deux nombres et retourne le quotient. 
Le reste est stock dans rfrence reste fournie.
Arguments:
- numerateur (entier) : Nombre  diviser;
- diviseur (entier) : Nombre par lequel on divise le numerateur;
- reste (pointeur d'entier): Le reste de la division
Retour: (entier) Le quotient de la division entire
Paramtres modifis:
- reste
*/
int division_entiere(int numerateur, int diviseur, int *reste);


/*
Fonction: main
Description:
Arguments:
- Aucuns
*/

int main(void)
{
	//dclaration de variables
	int numerateur; 
	int denumerateur; 
	int quotient, //Le quotient de la division
		reste; //Le reste de la division
	
	numerateur = 32;
	denumerateur = 7;
	quotient = division_entiere(numerateur, denumerateur, &reste);

	printf("%d / %d = %d et il reste %d\n\n", numerateur, denumerateur, quotient, reste);

	system("pause");
	return EXIT_SUCCESS;
}


/********* IMPLMENTATIONS DES FONCTION **************/
int division_entiere(int numerateur, int diviseur, int *reste)
{
	*reste = numerateur % diviseur;
	return numerateur / diviseur; 
}