/*
Titre: Exercice 7
Description: Programme permettant d'exprimenter l'encapsulation des informations de chaque
fonction dans son espace mmoire ddi.

Auteur: Anis Boubaker
Date: 2018-02-01
*/

/***********COMMANDES PRPROCESSEUR*************/
#define _CRT_SECURE_NO_WARNINGS
#include <stdlib.h>
#include <stdio.h>

/***********CONSTANTES DE COMPILATION*************/


/********* DCLARATIONS DES FONCTION **************/

/*
Fonction: lire_entier
Description: Saisit un entier et renvoie l'adresse de la variable o l'entier est stock
Arguments: Aucun
Paramtres modifis: Aucun
Retour: (pointeur d'entier) Adresse de la variable o l'entier saisit a t stock
*/
int *lire_entier();


/*
Fonction: main
Description: 
Arguments:
- Aucuns
*/

int main(void)
{
	//dclaration de variables
	int *saisie_ptr; //Pointeur vers la valeur saisie

	saisie_ptr = lire_entier();
	
	//NDE: La valeur obtenue ne peut tre considre comme fiable!
	//Il se peut que la valeur qu'on lit ici soit correcte, ou pas!
	printf("La valeur saisie est: %d\n", *saisie_ptr);

	//NDE: Ici on modifie une information  une adresse non affecte dans
	//la pile. C'est trs risqu et source de bug!
	(*saisie_ptr)--;
	printf("La valeur saisie est: %d\n", *saisie_ptr);

	system("pause");
	return EXIT_SUCCESS;
}


/********* IMPLMENTATIONS DES FONCTION **************/
int *lire_entier()
{
	//Dclaration de variables
	int saisie; //Valeur saisie par l'usager
	
	printf("Veuillez saisir un entier: ");
	scanf("%d", &saisie);

	//NDE: UNE FONCTION NE DEVRAIT JAMAIS RETOURER UN POINTEUR VERS
	//UNE DE SES VRAIBLES LOCALES!! 
	//Une variable locale sera dtruite ds lors qu'on sort de la fonction!
	return &saisie;
}