/*
Titre: Exercice3
Description: Programme illustre le passage de paramtres par rfrences: 
Deux valeurs sont saisies et elles sont permutes au sein d'une fonction.

Auteur: Anis Boubaker
Date:
*/

/***********COMMANDES PRPROCESSEUR*************/
#define _CRT_SECURE_NO_WARNINGS
#include <stdlib.h>
#include <stdio.h>

/***********CONSTANTES DE COMPILATION*************/


/********* DCLARATIONS DES FONCTION **************/
/*
Fonction: permuter
Description: Fonction qui permute les valeurs des deux refrences qu'elle reoit en paramtre
Arguments:
- entier1 (pointeur d'entier): Rfrence vers le premier entier  permuter
- entier2 (pointeur d'entier): Rfrence vers le second entier  permuter
Valeur retourne: Aucune
Paramtres modifis:
- entier1: obtient la valeur rfrence par entier2
- entier2: obtient la valeur rfrence par entier1
*/
void permuter(int *entier1, int *entier2);

/*
Fonction: main
Description:
Arguments:
- Aucuns
*/

int main(void)
{
	//Dclaration de variables
	int valeur1; //Premire valeur saisie
	int valeur2;  //2e valeur saisie

	printf("Veuillez saisir la valeur 1: ");
	scanf("%d", &valeur1);

	printf("Veuillez saisir la valeur 2: ");
	scanf("%d", &valeur2);

	//NDE: On ne passe pas le contenu des variables, MAIS leurs adresses!
	permuter(&valeur1, &valeur2);

	printf("Valeur1 = %d\n", valeur1);
	printf("Valeur2 = %d\n", valeur2);

	system("pause");
	return EXIT_SUCCESS;
}


/********* IMPLMENTATIONS DES FONCTION **************/
void permuter(int *entier1, int *entier2)
{
	//Dclaration de variables
	int copie_entier2;
	
	copie_entier2 = *entier2;
	*entier2 = *entier1;
	*entier1 = copie_entier2;
}